<template>
  <div class="home">
    <el-input placeholder="User hash" v-model="hash">
      <el-button slot="append" @click="connectToPeer(hash)">connect</el-button>
    </el-input>
    <el-alert
            :title="id"
            type="info"
            :closable="false"
    >
    </el-alert>
    <UserPlayer
      @play="onPlay"
      @pause="onPause"
      @seek="onSeek"
      :source="source"
    ></UserPlayer>
  </div>
</template>

<script>
import UserPlayer from "../components/UserPlayer";
import {mapState} from "vuex";
export default {
  name: 'Home',
  data: () => ({
    id: null,
    source: null,
    events: [],
    hash: '',
  }),
  computed: {
    ...mapState(['playerLink']),
  },
  components: {
    UserPlayer,
  },
  mounted() {
    this.$peer.on('open', id => {
      this.id = id;
    })
    this.$peer.on('connection', conn => {
      conn.on('open', () => {
        this.handleOpen(conn);
      })
      conn.on('data', (data) => this.handleData(conn, data))
    })
  },
  methods: {
    setNewSource(source, type = 'youtube') {
      const sourceObject = {
        type: 'video',
        sources: [
          {
            src: source,
            provider: 'youtube',
          },
        ],
      };
      this.source = sourceObject;
      this.$store.dispatch('broadcast', {
        type: 'source',
        data: sourceObject,
      })
    },
    addEvent(type) {
      this.events.push(type);
    },
    removeEvent(type) {
      this.events = this.events.filter(_=>_ !== type);
    },
    existsEvent(type) {
      return this.events.includes(type);
    },
    connectToPeer(userId) {
      let conn = this.$peer.connect(userId);
      conn.on('open', () => {
        this.handleOpen(conn)
      })
      conn.on('data',(data) => this.handleData(conn, data));
      this.hash = '';
    },
    handleData(connection, { type, data }) {
      console.log('<---', { type, data });
      this.addEvent(type);
      switch(type) {
        case 'source':
          this.source = data;
          break;
        case 'play':
          window.player.play();
          break;
        case 'pause':
          window.player.pause();
          break;
        case 'seek':
          window.player.currentTime = data;
          break;
        case 'message':
          this.$notify.info({
            title: `New message from ${connection.peer}`,
            message: data,
            showClose: false
          });
          break;
      }
    },
    handleOpen(connection) {
      this.$store.commit('addConnection', connection);
      this.$notify.success({
        title: 'New connection',
        message: `Connected to user ${connection.peer}`,
        showClose: false
      });
    },
    onPlay() {
      if(this.existsEvent('play')) return this.removeEvent('play');

      this.$store.dispatch('broadcast', {
        type: 'play',
      })
    },
    onPause() {
      if(this.existsEvent('pause')) return this.removeEvent('pause');

      this.$store.dispatch('broadcast', {
        type: 'pause',
      })
    },
    onSeek(event) {
      if(this.existsEvent('seek')) return this.removeEvent('seek');

      const currentTime = event.detail.plyr.currentTime;
      this.$store.dispatch('broadcast', {
        type: 'seek',
        data: currentTime,
      })

    }
  },
  watch: {
    playerLink(newVal) {
      const url = new URL(newVal);
      this.setNewSource(url.searchParams.get('v'));
    },
  }
}
</script>
